﻿* Encoding: UTF-8.
*Impute missing data
*SPSS macros by Kirill Orlov
*kior@comtv.ru, ttnphns@gmail.com
*https://www.spsstools.net/en/KO-spssmacros
*All rights reserved.

*/*!KO_HDIMPUTE*/vers3*************************************************************.
define !KO_hdimpute(vars= !charend('/') /nmiss= !charend('/') /bgvars= !charend('/') /varsbg= !charend('/') /discret= !charend('/')
                /match= !charend('/') /mult= !charend('/') /samp= !charend('/') /print= !charend('/') /kbins= !charend('/') !default(5))
!let !ok= 1 !let !bgvrs= !null !let !cnt= !null !let !cntbin= !null !let !tovarsbg= 1
!if (!tail(!vars)=!null) !then
 !if (!varsbg<>!null !or !discret<>!null) !then !let !tovarsbg= 0
- echo ' '.
- echo '>WARNING. Подкоманды VARSBG и DISCRET игнорируются, если VAR= одна переменная.'.
 !ifend
!else !let !varsbg_= !conc(' ',!varsbg,' ') !let !vars_= !conc(' ',!vars,' ')
 !do !w !in (!discret)
  !if (!index(!varsbg_,!conc(' ',!w,' '))=0 !or !index(!vars_,!conc(' ',!w,' '))=0) !then !let !ok= 0
-  echo ' '.
-  echo '>ERROR. В DISCRET указаны переменные, отсутствующие в VARSBG или VARS.'.
   !break
  !else !let !cntbin= !conc(!cntbin,' ')
  !ifend
 !doend !let !cntbin= !len(!cntbin)
 !do !w !in (!varsbg)
  !if (!index(!vars_,!conc(' ',!w,' '))=0) !then !let !ok= 0
-  echo ' '.
-  echo '>ERROR. В VARSBG указаны переменные, отсутствующие в VARS.'.
   !break
  !ifend
 !doend
!ifend
!if (!varsbg=!null) !then !let !tovarsbg= 0 !ifend
!let !newvars= !null !let !tnewvars= !null !let !donors= !null !let !vr= !null
!do !w !in (!vars)
 !let !newvars= !conc(!newvars,' impute_',!w) !let !tnewvars= !conc(!tnewvars,' timpute#$_',!w)
 !let !donors= !conc(!donors,' donor_',!w) !let !vr= !conc(!vr,' ',!w,'_fst#$#$')
!doend
!do !w !in (!bgvars) !let !cnt= !conc(!cnt,' ') !doend
!let !cnt= !len(!cnt)
!if (!cnt=1) !then !let !bgvrs= '#1' !else !let !bgvrs= !conc('#1 to #',!cnt) !ifend
!if (!nmiss=!null !or !nmiss='ALL') !then !let !ok= 0
-echo ' '.
-echo '>ERROR. В NMISS не задано число.'.
!else !if (!tail(!nmiss)=' ALL') !then !let !hnmiss= !head(!nmiss) !let !nmiss2= !null
 !do !w !in (!vars) !let !nmiss2= !conc(!nmiss2,' ',!hnmiss) !doend
!else !let !nmiss2= !nmiss
 !do !w !in (!vars)
  !if (!nmiss2=!null) !then !let !nmiss2= ' ' !break !ifend
  !let !nmiss2= !tail(!nmiss2)
 !doend
 !if (!nmiss2<>!null) !then !let !ok= 0
- echo ' '.
- echo '>ERROR. Список NMISS не равен по длине списку VARS.'.
 !else !let !nmiss2= !nmiss
 !ifend
!ifend !ifend
!if ((!head(!match)='ANY' !or !head(!match)='HIE') !and !tail(!match)=!null) !then !let !ok= 0
-echo ' '.
-echo '>ERROR. Не задан числовой параметр после MATCH=ANY или MATCH=HIE.'.
!ifend
!if (!head(!match)='ALL' !and !tail(!match)<>!null) !then !let !ok= 0
-echo ' '.
-echo '>ERROR. MATCH=ALL не нуждается в дополнительном параметре после ALL.'.
!ifend
!if (!tail(!match)<>!null) !then !let !mtch= !head(!tail(!match))
 !if ((!len(!cnt)=!len(!mtch) !and !cnt<=!mtch) !or !len(!cnt)<!len(!mtch)) !then !let !ok= 0
- echo ' '.
- echo '>ERROR. Число при MATCH=ANY/HIE должно быть меньше чем число переменных BGVARS.'.
 !else
  !let !cnt= !mtch
 !ifend
!ifend
!if (!ok) !then
-echo ' '.
-echo '**** КОЛОДНАЯ ИМПУТАЦИЯ !KO_HDIMPUTE ****'.
 !let !atone= (!mult<>'INDEP') !let !norepl= (!samp<>'REPLACE')
 !if (!norepl) !then !let !notused= 'and notused#$#$'
  !if (!samp='NOREPLACE' !or !samp=!null) !then !let !maxnuse= 1 !else !let !maxnuse= !samp !ifend
 !ifend
 !if (!tovarsbg) !then
  !let !vrsbg= !null !let !binned= !null !let !discret_= !conc(' ',!discret,' ') !let !i= !null !let !#vrsbg= !null
  !do !i= 1 !to !cntbin !let !binned= !conc(!binned,' bin',!i,'#$#$') !doend
  !if (!discret<>!null) !then
-  echo ' '.
-  echo '** ОТЧЕТ О ВНУТРЕННЕЙ ДИСКРЕТИЗАЦИИ (RANK) ПЕРЕМЕННЫХ, УКАЗАННЫХ в DISCRET **'.
-  rank vari= !discret /ntiles(!kbins) into !binned /print= yes /ties= mean.
  !ifend
  !do !w !in (!varsbg)
   !if (!index(!discret_,!conc(' ',!w,' '))=0) !then !let !vrsbg= !conc(!vrsbg,' ',!w) !ifend
   !let !i= !conc(!i,' ') !let !#vrsbg= !conc(!#vrsbg,' #vbg',!len(!i))
  !doend
  !let !vrsbg= !conc(!vrsbg,' ',!binned)
 !ifend
 !if (!print='YES') !then
- echo ' '.
- echo '** ДИНАМИЧЕСКАЯ РАСПЕЧАТКА ИМПУТАЦИИ **'.
  !if (!atone !and !tail(!vars)<>!null) !then
- echo ' '.
- echo 'При MULT=ATONE, в распечатке "Заодно"=1, если данная импутация на самом деле'.
- echo 'была сделана "заодно" при обработке более ранних переменных списка VARS.'.
  !ifend
 !ifend
-numer !newvars !if (!atone) !then !tnewvars !ifend !donors case#$#$ (f8) notused#$#$ numused#$#$ valid#$#$ break#$#$ newreci#$#$ nmatch#$#$ @i@#$#$.
-recode !vars (miss=sysmis) (else=copy) into !newvars.
-comp case#$#$= $casenum.
-comp notused#$#$= 1.
-comp numused#$#$= 0.
-comp newreci#$#$= 1.
-aggr /outfile= * mode= addvari /filt#$#$= first(case#$#$).
 !let !newvrs= !newvars !let !tnewvrs= !tnewvars !let !donrs= !donors !let !vr2= !vr !let !notv1= 0
 !do !var !in (!vars)
  !let !nmss= !head(!nmiss2) !let !nmiss2= !tail(!nmiss2)
  !if (!var<>!head(!vars)) !then !let !notv1= 1 !ifend
  !let !newvar= !head(!newvrs) !let !newvrs= !tail(!newvrs) !let !donor= !head(!donrs) !let !donrs= !tail(!donrs)
  !let !tnewvar= !head(!tnewvrs) !let !tnewvrs= !tail(!tnewvrs)
  !let !vr1= !head(!vr) !let !vr= !tail(!vr)
  !if (!atone !and !vr<>!null) !then !let !vrfst= !conc('/',!vr,'=first(',!newvrs,') ')
   !let !rec1= !conc('recode ',!newvrs,' (sysmis=-999.195385798472)')
   !let !rec2= !conc('recode ',!newvrs,' (else=sysmis)')
   !let !rec3= !conc('recode ',!newvrs,' ',!vr,' (-999.195385798472=sysmis)')
  !else !let !vrfst= !null
  !ifend
- apply dict from * /source var= !var /target var= !newvar.
- comp nmatch#$#$= unif(1).
- comp @i@#$#$= 0.
- do if $casenum=1.
-  write outfile= 'temp_KO_hdimpute_1.sps'
      /'comp @i@#$#$= @i@#$#$+1.'
      /'do if $casenum=@i@#$#$.'
      /'recode ' !quote(!bgvars) ' (else=copy) into ' !quote(!bgvrs) '.'
    !if (!tovarsbg) !then
      /'recode ' !quote(!vrsbg) ' (else=copy) into ' !quote(!#vrsbg) '.'
    !ifend
      /'end if.'
      /'do if break#$#$=2.'
      /'comp nmatch#$#$= 0.'
      /'comp #prev= 1.'
      /'do rep v=' !quote(!bgvars) ' /#v=' !quote(!bgvrs) '.'
    !if (!head(!match)='HIE') !then
      /'do if #prev and v=#v.'
      /'comp nmatch#$#$= nmatch#$#$+1.'
      /'else.'
      /'comp #prev= 0.'
      /'end if.'
    !else
      /'if v=#v nmatch#$#$= nmatch#$#$+1.'
    !ifend
      /'end rep.'
      /'if nmatch#$#$<' !quote(!cnt) ' nmatch#$#$= 0.'
    !if (!tovarsbg) !then
      /'comp nmatch2#$#$= 0.'
      /'do rep v=' !quote(!vrsbg) ' /#v=' !quote(!#vrsbg) '.'
      /'if v=#v nmatch2#$#$= nmatch2#$#$+1.'
      /'end rep.'
      /'do if nmatch#$#$*nmatch2#$#$=0.'
      /'comp nmatch#$#$= 0.'
      /'else.'
      /'comp nmatch#$#$= nmatch#$#$+nmatch2#$#$.'
      /'end if.'
    !ifend
      /'comp nmatch#$#$= unif(nmatch#$#$*nmatch#$#$).'
      /'else.'
      /'comp nmatch#$#$= $sysmis.'
      /'end if.'
      /'sort cases by break#$#$ (a) notused#$#$ nmatch#$#$ (d).'.
-  write outfile= 'temp_KO_hdimpute_2.sps'
      /'do if break#$#$=2 and nmatch#$#$>0 ' !quote(!notused) '.'
      /'comp break#$#$= 1.'
      /!quote(!rec1) '.'
      /'end if.'
      /'temp.'
      /'do if not valid#$#$.'
      /'comp case#$#$= $sysmis.'
      /!quote(!rec2) '.'
      /'end if.'
      /'aggr /outfile= * mode= addvari /presorted /break= break#$#$'
      /' /' !quote(!vr1) '= first(' !quote(!newvar) ') ' !quote(!vrfst) ' /dcase#$#$= first(case#$#$).'
      /!quote(!rec3) '.'
      /'do if $casenum=@i@#$#$ and not valid#$#$.'
    !if (!atone) !then
      /'do if not sysmis(' !quote(!tnewvar) ').'
      /'comp ' !quote(!newvar) '= ' !quote(!tnewvar) '.'
      /'comp #idledon= 1.'
      /'format #idledon (f8).'
      /'else.'
      /'comp ' !quote(!newvar) '= ' !quote(!vr1) '.'
      /'comp ' !quote(!donor) '= dcase#$#$.'
     !if (!vrfst<>!null) !then
      /'do rep v=' !quote(!newvrs) ' /tv=' !quote(!tnewvrs) ' /vr=' !quote(!vr) ' /dr=' !quote(!donrs) '.'
      /'do if sysmis(tv).'
      /'do if sysmis(v) and not sysmis(vr).'
      /'comp tv= vr.'
      /'comp dr= dcase#$#$.'
      /'end if.'
      /'end if.'
      /'end rep.'
     !ifend
      /'end if.'
    !else
      /'comp ' !quote(!newvar) '=' !quote(!vr1) '.'
      /'comp ' !quote(!donor) '= dcase#$#$.'
    !ifend
      /'comp break#$#$= 0.'
      /'comp newreci#$#$= 0.'
    !if (!print='YES') !then
      /'do if $casenum=1.'
      /'print space.'
      /"print /" !quote(!quote(!conc('Обрабатываемая переменная: ',!var))) " /'Обработанные наблюдения-пропуски:'"
      /" /'       # ' ' НомерНабл ' ' ЗначПропуск ' ' ИмпутирЗнач ' ' НаблДонор '" !if (!atone !and !notv1) !then " ' Заодно '" !ifend "."
      /'end if.'
      /"print /$casenum ' ' case#$#$ ' ' " !quote(!var) " '   ' " !quote(!newvar) " '    ' " !quote(!donor) !if (!atone !and !notv1) !then " #idledon" !ifend "."
    !ifend
      /'else if valid#$#$ and break#$#$=1.'
      /'comp break#$#$= 2.'
    !if (!norepl) !then
      /'do if not lag(valid#$#$).'
     !if (!atone) !then
      /'do if not #idledon.'
     !ifend
      /'comp numused#$#$= numused#$#$+1.'
      /'if numused#$#$=' !quote(!maxnuse) ' notused#$#$= 0.'
     !if (!atone) !then
      /'end if.'
     !ifend
      /'end if.'
    !ifend
      /'end if.'.
- end if.
- sort cases by filt#$#$ (d) !newvar newreci#$#$ nmatch#$#$ (a).
  !if (!print='YES') !then
-  do if $casenum=1 and not sysmis(!newvar).
-   print space.
-   print /!quote(!conc('Обрабатываемая переменная: ',!var)) /'не содержит пропусков для импутации.'.
-  end if.
  !ifend
- comp valid#$#$= 1.
- do if not sysmis(filt#$#$) and sysmis(!newvar) and $casenum<=!nmss.
-  comp valid#$#$= 0.
-  comp break#$#$= 1.
- else if sysmis(!newvar).
-  comp break#$#$= 3.
- else.
-  comp break#$#$= 2.
- end if.
  !if (!print='YES') !then
   !if (!nmss=0) !then
-   do if $casenum=1.
-    print space.
-    print /!quote(!conc('Обрабатываемая переменная: ',!var)) /'не имеет заказа на импутацию пропусков (NMISS=0).'.
-   end if.
   !ifend
  !ifend
  !do !i= 1 !to !nmss
-  insert file= 'temp_KO_hdimpute_1.sps'.
   !if (!atone) !then
    !if (!notv1 !or !i>1) !then
-    del vari !vr1 !vr dcase#$#$.
    !ifend
   !else
    !if (!i>1) !then
-    del vari !vr1 dcase#$#$.
    !else !if (!notv1) !then
-    del vari dcase#$#$.
    !ifend !ifend
   !ifend
-  insert file= 'temp_KO_hdimpute_2.sps'.
  !doend
- if sysmis(!newvar) !newvar= value(!var).
- if break#$#$=0 and miss(!newvar) !donor= 0.
- if break#$#$=3 !donor= -1.
 !doend
-var lab !do !w !in (!donors) !w 'Номер наблюдения-донора, импутировавшего данный пропуск' !doend.
-val lab !donors 0 'Не удалось импутировать' -1 'Не подвергалось импутации'.
-var lev !donors (nom).
-format !donors (f8).
-sort cases by case#$#$.
-del vari case#$#$ break#$#$ newreci#$#$ nmatch#$#$ @i@#$#$ notused#$#$ numused#$#$ valid#$#$ dcase#$#$ filt#$#$ !vr2
    !if (!atone) !then !tnewvars !ifend !if (!tovarsbg) !then !binned nmatch2#$#$ !ifend.
-erase file 'temp_KO_hdimpute_1.sps'.
-erase file 'temp_KO_hdimpute_2.sps'.
!ifend
!enddefine.

*/*!KO_HOTDECK*/vers3*************************************************************.
define !KO_hotdeck(vars= !charend('/') /bgvars= !charend('/') /samp= !charend('/'))
-echo ' '.
-echo '**** КОЛОДНАЯ ИМПУТАЦИЯ !KO_HOTDECK ****'.
!let !lead1= !null !let !lead2= !null !let !lead3= !null !let !used1= !null !let !used2= !null !let !used3= !null
!let !lagused1= !null !let !lagused2= !null !let !newvars= !null !let !donors= !null
!do !var !in (!vars)
 !let !lead1= !conc(!lead1,' ',!var,'lead1#$#$') !let !lead2= !conc(!lead2,' ',!var,'lead2#$#$') !let !lead3= !conc(!lead3,' ',!var,'lead3#$#$')
 !let !used1= !conc(!used1,' ',!var,'used1#$#$') !let !used2= !conc(!used2,' ',!var,'used2#$#$') !let !used3= !conc(!used3,' ',!var,'used3#$#$')
 !let !lagused1= !conc(!lagused1,' ',!var,'lagused1#$#$') !let !lagused2= !conc(!lagused2,' ',!var,'lagused2#$#$')
 !let !newvars= !conc(!newvars,' impute_',!var) !let !donors= !conc(!donors,' donor_',!var)
!doend
!if (!samp<>'REPLACE') !then !let !rrepl= 1
 !let !compused1= 'comp used1= 1' !let !compused2= 'comp used2= 1' !let !compused3= 'comp used3= 1'
 !let !complagu1= 'comp lagused1= 1' !let !complagu2= 'comp lagused2= 1'
 !let !notuseda= 'and not any(1,lag(used1,2),lag(used2,3),lag(used3,4))'
 !let !notusedb= 'and not any(1,lag(used1,3),lag(used2,4),lag(used3,5),lag(lagused1))'
 !let !notusedc= 'and not any(1,lag(used1,4),lag(used2,5),lag(used3,6),lag(lagused1,2),lag(lagused2))'
 !let !notusedd= 'and not any(1,lag(used2),lag(used3,2))'
 !let !notusede= 'and not any(1,lag(used3))'
!else !let !rrepl= 0
!ifend
numer !newvars !donors (f8) case#$#$ rand#$#$ aslag1#$#$ aslag2#$#$ aslag3#$#$
      aslead1#$#$ aslead2#$#$ aslead3#$#$ !if (!rrepl) !then !used1 !used2 !used3 !lagused1 !lagused2 !ifend.
!let !newvrs= !newvars
!do !var !in (!vars) !let !newvar= !head(!newvrs) !let !newvrs= !tail(!newvrs)
-apply dict from * /source var= !var /target var= !newvar.
-comp !newvar= !var.
!doend
comp case#$#$= $casenum.
comp rand#$#$= unif(1).
recode aslag1#$#$ aslag2#$#$ aslag3#$#$ aslead1#$#$ aslead2#$#$ aslead3#$#$ (else=1).
!if (!rrepl) !then
-recode !used1 !used2 !used3 !lagused1 !lagused2 (else=0).
!ifend
sort cases by !bgvars rand#$#$.
set results none errors none.
!do !v !in (!bgvars)
-create leadbg1#$#$= lead(!v,1) /leadbg2#$#$= lead(!v,2) /leadbg3#$#$= lead(!v,3).
-do if miss(!v).
- recode aslag1#$#$ aslag2#$#$ aslag3#$#$ aslead1#$#$ aslead2#$#$ aslead3#$#$ (else=0).
-else.
- if lag(!v)<>!v or miss(lag(!v)) aslag1#$#$= 0.
- if lag(!v,2)<>!v or miss(lag(!v,2)) aslag2#$#$= 0.
- if lag(!v,3)<>!v or miss(lag(!v,3)) aslag3#$#$= 0.
- if leadbg1#$#$<>!v or miss(leadbg1#$#$) aslead1#$#$= 0.
- if leadbg2#$#$<>!v or miss(leadbg2#$#$) aslead2#$#$= 0.
- if leadbg3#$#$<>!v or miss(leadbg3#$#$) aslead3#$#$= 0.
-end if.
!doend
create !lead1= lead(!vars,1) /!lead2= lead(!vars,2) /!lead3= lead(!vars,3)
      /case1#$#$= lead(case#$#$,1) /case2#$#$= lead(case#$#$,2) /case3#$#$= lead(case#$#$,3).
set results list errors list.
do rep newvar= !newvars /var= !vars /donor= !donors /lead1= !lead1 /lead2= !lead2 /lead3= !lead3
      /used1= !used1 /used2= !used2 /used3= !used3 /lagused1= !lagused1 /lagused2= !lagused2.
-do if sysmis(newvar).
- do if aslead1#$#$ and not miss(lead1) !notusedd.
-  comp newvar= lead1.
-  comp donor= case1#$#$.
-  !compused1.
- else if aslead2#$#$ and not miss(lead2) !notusede.
-  comp newvar= lead2.
-  comp donor= case2#$#$.
-  !compused2.
- else if aslead3#$#$ and not miss(lead3).
-  comp newvar= lead3.
-  comp donor= case3#$#$.
-  !compused3.
- else if aslag1#$#$ and not miss(lag(var)) !notuseda.
-  comp newvar= lag(var).
-  comp donor= lag(case#$#$).
-  !complagu1.
- else if aslag2#$#$ and not miss(lag(var,2)) !notusedb.
-  comp newvar= lag(var,2).
-  comp donor= lag(case#$#$,2).
-  !complagu2.
- else if aslag3#$#$ and not miss(lag(var,3)) !notusedc.
-  comp newvar= lag(var,3).
-  comp donor= lag(case#$#$,3).
- end if.
-end if.
-if sysmis(newvar) newvar= value(var).
-if miss(var) and miss(newvar) donor= 0.
end rep.
exec.
var lab !do !w !in (!donors) !w 'Номер наблюдения-донора, импутировавшего данный пропуск' !doend.
val lab !donors 0 'Не удалось импутировать'.
var lev !donors (nom).
sort cases by case#$#$.
del vari case#$#$ rand#$#$ aslag1#$#$ aslag2#$#$ aslag3#$#$ aslead1#$#$ aslead2#$#$ aslead3#$#$ leadbg1#$#$ leadbg2#$#$ leadbg3#$#$
    !lead1 !lead2 !lead3 case1#$#$ case2#$#$ case3#$#$ !if (!rrepl) !then !used1 !used2 !used3 !lagused1 !lagused2 !ifend.
!enddefine.

*/*!KO_BORROW*/vers1*************************************************************.
define !KO_borrow(vars= !charend('/') /donor= !charend('/') /ifrecval= !charend('/') /ifdonval= !charend('/') /cap= !charend('/'))
!let !fvars= !null !let !newvars= !null !let !cp= !unquote(!cap)
!do !w !in (!vars)
 !let !fvars= !conc(!fvars,' fst#$',!w) !let !newvars= !conc(!newvars,' ',!cp,!w)
!doend
!if (!ifrecval='ANY') !then !let !rec= 1 !ifend
!if (!ifrecval='MISSING' !or !ifrecval=!null) !then !let !rec= 'miss(var)' !ifend
!if (!ifrecval='SYSMIS') !then !let !rec= 'sysmis(var)' !ifend
!if (!ifrecval='VALID') !then !let !rec= 'not miss(var)' !ifend
!if (!ifrecval='BLANK') !then !let !rec= 'var=" "' !ifend
!if (!ifdonval='ANY') !then !let !don= 1 !ifend
!if (!ifdonval='MISSING') !then !let !don= 'miss(fvar)' !ifend
!if (!ifdonval='SYSMIS') !then !let !don= 'sysmis(fvar)' !ifend
!if (!ifdonval='VALID' !or !ifdonval=!null) !then !let !don= 'not miss(fvar)' !ifend
!if (!ifdonval='BLANK') !then !let !don= 'fvar=" "' !ifend
exec.
filter off.
use all.
aggreg /outfile= * mode= addvari /ncas#$#$= nu.
dataset copy temp#$$$$$._ window= hidden.
comp case#$#$= $casenum.
add files file= * /file= temp#$$$$$._.
if not sysmis(case#$#$) !donor= case#$#$.
temp.
miss val !vars ().
set results none errors none.
recode !vars (sysmis=-999.999195385798472).
aggreg /outfile= * mode= addvari /break= !donor
       /!fvars= first(!vars).
apply dict from temp#$$$$$._ /fileinfo weight.
dataset close temp#$$$$$._.
!do !w !in (!vars)
-apply dict from= * /source var= !w
                    /target vari= !conc('fst#$',!w) !if (!cap<>!null) !then !conc(!cp,!w) !ifend
                    /newvar.
!doend
select if sysmis(case#$#$).
recode !fvars (-999.999195385798472=sysmis).
recode !vars (else=copy) into !newvars.
set results list errors list.
do if range(!donor,1,ncas#$#$) and rnd(!donor)=!donor.
-do rep var= !vars /fvar= !fvars /newvar= !newvars.
- do if !rec and !don.
-  recode fvar (else=copy) into newvar.
- end if.
-end rep.
end if.
exec.
del vari case#$#$ ncas#$#$ !fvars.
!enddefine.
